import {createAsyncThunk} from "@reduxjs/toolkit";
import axiosApi from "../../api/axiosApi";
import {setLoginError, setRegisterError, setUser} from "../services/usersSlice";

export const registerUser = createAsyncThunk(
    'users/register',
    async (payload, {dispatch}) => await axiosApi
        .post('/users', payload.data)
        .then(res => payload.callback())
        .catch(e => {
            if (e?.response?.data) dispatch(setRegisterError(e.response.data));
            else dispatch(setRegisterError(e));
            throw e;
        })
);

export const loginUser = createAsyncThunk(
    'users/login',
    async (payload, {dispatch, getState}) => await axiosApi
        .post('/users/login', payload.data)
        .then(res => {
            dispatch(setUser(res.data));
            payload.callback();
        })
        .catch(e => {
            if (e?.response?.data) dispatch(setLoginError(e.response.data));
            else dispatch(setLoginError(e));
            throw e;
        })
);
